/* puzzle.c generated by valac 0.56.17, the Vala compiler
 * generated from puzzle.vala, do not modify */

/*
   This file is part of GNOME Klotski.

   Copyright (C) 2010-2013 Robert Ancell

   GNOME Klotski is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Klotski is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with GNOME Klotski.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PUZZLE (puzzle_get_type ())
#define PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE, Puzzle))
#define PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE, PuzzleClass))
#define IS_PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE))
#define IS_PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE))
#define PUZZLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE, PuzzleClass))

typedef struct _Puzzle Puzzle;
typedef struct _PuzzleClass PuzzleClass;
typedef struct _PuzzlePrivate PuzzlePrivate;
enum  {
	PUZZLE_0_PROPERTY,
	PUZZLE_WIDTH_PROPERTY,
	PUZZLE_HEIGHT_PROPERTY,
	PUZZLE_INITIAL_MAP_PROPERTY,
	PUZZLE_MOVES_PROPERTY,
	PUZZLE_NUM_PROPERTIES
};
static GParamSpec* puzzle_properties[PUZZLE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	PUZZLE_CHANGED_SIGNAL,
	PUZZLE_MOVED_SIGNAL,
	PUZZLE_NUM_SIGNALS
};
static guint puzzle_signals[PUZZLE_NUM_SIGNALS] = {0};

struct _Puzzle {
	GObject parent_instance;
	PuzzlePrivate * priv;
	gchar* map;
	gint map_length1;
	gint _map_size_;
	gchar* move_map;
	gint move_map_length1;
	gint _move_map_size_;
	gchar* orig_map;
	gint orig_map_length1;
	gint _orig_map_size_;
	gchar* lastmove_map;
	gint lastmove_map_length1;
	gint _lastmove_map_size_;
	gchar* undomove_map;
	gint undomove_map_length1;
	gint _undomove_map_size_;
};

struct _PuzzleClass {
	GObjectClass parent_class;
};

struct _PuzzlePrivate {
	guint8 image_map_length;
	guint8 _width;
	guint8 _height;
	gchar* _initial_map;
	guint16 _moves;
};

static gint Puzzle_private_offset;
static gpointer puzzle_parent_class = NULL;

VALA_EXTERN GType puzzle_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Puzzle, g_object_unref)
VALA_EXTERN Puzzle* puzzle_new (guint8 width,
                    guint8 height,
                    const gchar* initial_map);
VALA_EXTERN Puzzle* puzzle_construct (GType object_type,
                          guint8 width,
                          guint8 height,
                          const gchar* initial_map);
VALA_EXTERN gchar puzzle_get_piece_id (Puzzle* self,
                           gchar* src,
                           gint src_length1,
                           guint8 x,
                           guint8 y);
VALA_EXTERN guint8 puzzle_get_width (Puzzle* self);
static void puzzle_set_piece_id (Puzzle* self,
                          gchar* src,
                          gint src_length1,
                          guint8 x,
                          guint8 y,
                          gchar id);
VALA_EXTERN gint puzzle_get_piece_nr (Puzzle* self,
                          guint8 x,
                          guint8 y);
VALA_EXTERN gboolean puzzle_game_over (Puzzle* self);
VALA_EXTERN guint8 puzzle_get_height (Puzzle* self);
VALA_EXTERN gboolean puzzle_mapcmp (Puzzle* self,
                        gchar* m1,
                        gint m1_length1,
                        gchar* m2,
                        gint m2_length1);
VALA_EXTERN gboolean puzzle_is_static_tile (gchar id);
VALA_EXTERN gboolean puzzle_move_piece (Puzzle* self,
                            gchar id,
                            guint8 x1,
                            guint8 y1,
                            guint8 x2,
                            guint8 y2);
static gboolean puzzle_check_valid_move (Puzzle* self,
                                  gchar id,
                                  gint8 dx,
                                  gint8 dy);
static gboolean puzzle_do_move_piece (Puzzle* self,
                               gchar id,
                               gint8 dx,
                               gint8 dy);
VALA_EXTERN gboolean puzzle_can_be_moved (Puzzle* self,
                              gchar id);
static gchar* _vala_array_dup1 (gchar* self,
                         gssize length);
static gchar* _vala_array_dup2 (gchar* self,
                         gssize length);
static void puzzle_set_width (Puzzle* self,
                       guint8 value);
static void puzzle_set_height (Puzzle* self,
                        guint8 value);
static const gchar* puzzle_get_initial_map (Puzzle* self);
static void puzzle_set_initial_map (Puzzle* self,
                             const gchar* value);
VALA_EXTERN guint16 puzzle_get_moves (Puzzle* self);
VALA_EXTERN void puzzle_set_moves (Puzzle* self,
                       guint16 value);
static GObject * puzzle_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties);
static gchar* _vala_array_dup3 (gchar* self,
                         gssize length);
static gchar* _vala_array_dup4 (gchar* self,
                         gssize length);
static gchar* _vala_array_dup5 (gchar* self,
                         gssize length);
static gchar* _vala_array_dup6 (gchar* self,
                         gssize length);
static void puzzle_finalize (GObject * obj);
static GType puzzle_get_type_once (void);
static void _vala_puzzle_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_puzzle_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const guint8 PUZZLE_image_map[108] = {(guint8) 0, (guint8) 0, (guint8) 64, (guint8) 1, (guint8) 66, (guint8) 2, (guint8) 2, (guint8) 3, (guint8) 16, (guint8) 4, (guint8) 24, (guint8) 5, (guint8) 8, (guint8) 6, (guint8) 208, (guint8) 7, (guint8) 248, (guint8) 8, (guint8) 104, (guint8) 9, (guint8) 214, (guint8) 10, (guint8) 255, (guint8) 11, (guint8) 107, (guint8) 12, (guint8) 22, (guint8) 13, (guint8) 31, (guint8) 14, (guint8) 11, (guint8) 15, (guint8) 18, (guint8) 16, (guint8) 10, (guint8) 17, (guint8) 80, (guint8) 18, (guint8) 72, (guint8) 19, (guint8) 25, (guint8) 5, (guint8) 28, (guint8) 5, (guint8) 56, (guint8) 5, (guint8) 152, (guint8) 5, (guint8) 184, (guint8) 5, (guint8) 29, (guint8) 5, (guint8) 67, (guint8) 2, (guint8) 70, (guint8) 2, (guint8) 98, (guint8) 2, (guint8) 194, (guint8) 2, (guint8) 99, (guint8) 2, (guint8) 198, (guint8) 2, (guint8) 9, (guint8) 6, (guint8) 40, (guint8) 6, (guint8) 20, (guint8) 4, (guint8) 144, (guint8) 4, (guint8) 3, (guint8) 3, (guint8) 6, (guint8) 3, (guint8) 96, (guint8) 1, (guint8) 192, (guint8) 1, (guint8) 224, (guint8) 1, (guint8) 14, (guint8) 17, (guint8) 42, (guint8) 17, (guint8) 46, (guint8) 17, (guint8) 19, (guint8) 16, (guint8) 146, (guint8) 16, (guint8) 147, (guint8) 16, (guint8) 73, (guint8) 19, (guint8) 200, (guint8) 19, (guint8) 201, (guint8) 19, (guint8) 84, (guint8) 18, (guint8) 112, (guint8) 18, (guint8) 116, (guint8) 18, (guint8) 26, (guint8) 25};

static inline gpointer
puzzle_get_instance_private (Puzzle* self)
{
	return G_STRUCT_MEMBER_P (self, Puzzle_private_offset);
}

Puzzle*
puzzle_construct (GType object_type,
                  guint8 width,
                  guint8 height,
                  const gchar* initial_map)
{
	Puzzle * self = NULL;
#line 146 "../src/puzzle.vala"
	g_return_val_if_fail (initial_map != NULL, NULL);
#line 148 "../src/puzzle.vala"
	self = (Puzzle*) g_object_new (object_type, "width", width, "height", height, "initial-map", initial_map, NULL);
#line 146 "../src/puzzle.vala"
	return self;
#line 216 "puzzle.c"
}

Puzzle*
puzzle_new (guint8 width,
            guint8 height,
            const gchar* initial_map)
{
#line 146 "../src/puzzle.vala"
	return puzzle_construct (TYPE_PUZZLE, width, height, initial_map);
#line 226 "puzzle.c"
}

gchar
puzzle_get_piece_id (Puzzle* self,
                     gchar* src,
                     gint src_length1,
                     guint8 x,
                     guint8 y)
{
	guint8 _tmp0_;
	gchar _tmp1_;
	gchar result;
#line 169 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, '\0');
#line 171 "../src/puzzle.vala"
	_tmp0_ = self->priv->_width;
#line 171 "../src/puzzle.vala"
	_tmp1_ = src[(((guint16) x) + 1) + ((((guint16) y) + 1) * (((guint16) _tmp0_) + 2))];
#line 171 "../src/puzzle.vala"
	result = _tmp1_;
#line 171 "../src/puzzle.vala"
	return result;
#line 249 "puzzle.c"
}

static void
puzzle_set_piece_id (Puzzle* self,
                     gchar* src,
                     gint src_length1,
                     guint8 x,
                     guint8 y,
                     gchar id)
{
	guint8 _tmp0_;
#line 174 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/puzzle.vala"
	_tmp0_ = self->priv->_width;
#line 176 "../src/puzzle.vala"
	src[(((guint16) x) + 1) + ((((guint16) y) + 1) * (((guint16) _tmp0_) + 2))] = id;
#line 267 "puzzle.c"
}

gint
puzzle_get_piece_nr (Puzzle* self,
                     guint8 x,
                     guint8 y)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	gchar c = '\0';
	gchar* _tmp2_;
	gint _tmp2__length1;
	guint8 _tmp3_;
	gchar _tmp4_;
	guint8 nr = 0U;
	gchar* _tmp5_;
	gint _tmp5__length1;
	guint8 _tmp6_;
	gchar _tmp7_;
	gchar* _tmp8_;
	gint _tmp8__length1;
	guint8 _tmp9_;
	gchar _tmp10_;
	gchar* _tmp11_;
	gint _tmp11__length1;
	guint8 _tmp12_;
	gchar _tmp13_;
	gchar* _tmp14_;
	gint _tmp14__length1;
	guint8 _tmp15_;
	gchar _tmp16_;
	gchar* _tmp17_;
	gint _tmp17__length1;
	guint8 _tmp18_;
	gchar _tmp19_;
	gchar* _tmp20_;
	gint _tmp20__length1;
	guint8 _tmp21_;
	gchar _tmp22_;
	gchar* _tmp23_;
	gint _tmp23__length1;
	guint8 _tmp24_;
	gchar _tmp25_;
	gchar* _tmp26_;
	gint _tmp26__length1;
	guint8 _tmp27_;
	gchar _tmp28_;
	gint result;
#line 179 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 181 "../src/puzzle.vala"
	_tmp0_ = x;
#line 181 "../src/puzzle.vala"
	x = _tmp0_ + 1;
#line 182 "../src/puzzle.vala"
	_tmp1_ = y;
#line 182 "../src/puzzle.vala"
	y = _tmp1_ + 1;
#line 184 "../src/puzzle.vala"
	_tmp2_ = self->map;
#line 184 "../src/puzzle.vala"
	_tmp2__length1 = self->map_length1;
#line 184 "../src/puzzle.vala"
	_tmp3_ = self->priv->_width;
#line 184 "../src/puzzle.vala"
	_tmp4_ = _tmp2_[((guint16) x) + (((guint16) y) * (((guint16) _tmp3_) + 2))];
#line 184 "../src/puzzle.vala"
	c = _tmp4_;
#line 185 "../src/puzzle.vala"
	if (c == '-') {
#line 186 "../src/puzzle.vala"
		result = 23;
#line 186 "../src/puzzle.vala"
		return result;
#line 342 "puzzle.c"
	}
#line 187 "../src/puzzle.vala"
	if (c == ' ') {
#line 188 "../src/puzzle.vala"
		result = 21;
#line 188 "../src/puzzle.vala"
		return result;
#line 350 "puzzle.c"
	}
#line 189 "../src/puzzle.vala"
	if (c == '.') {
#line 190 "../src/puzzle.vala"
		result = 20;
#line 190 "../src/puzzle.vala"
		return result;
#line 358 "puzzle.c"
	}
#line 192 "../src/puzzle.vala"
	nr = (guint8) 0;
#line 193 "../src/puzzle.vala"
	_tmp5_ = self->map;
#line 193 "../src/puzzle.vala"
	_tmp5__length1 = self->map_length1;
#line 193 "../src/puzzle.vala"
	_tmp6_ = self->priv->_width;
#line 193 "../src/puzzle.vala"
	_tmp7_ = _tmp5_[(((guint16) x) - 1) + ((((guint16) y) - 1) * (((guint16) _tmp6_) + 2))];
#line 193 "../src/puzzle.vala"
	if (_tmp7_ == c) {
#line 194 "../src/puzzle.vala"
		nr += (guint8) 1;
#line 374 "puzzle.c"
	}
#line 195 "../src/puzzle.vala"
	_tmp8_ = self->map;
#line 195 "../src/puzzle.vala"
	_tmp8__length1 = self->map_length1;
#line 195 "../src/puzzle.vala"
	_tmp9_ = self->priv->_width;
#line 195 "../src/puzzle.vala"
	_tmp10_ = _tmp8_[((guint16) x) + ((((guint16) y) - 1) * (((guint16) _tmp9_) + 2))];
#line 195 "../src/puzzle.vala"
	if (_tmp10_ == c) {
#line 196 "../src/puzzle.vala"
		nr += (guint8) 2;
#line 388 "puzzle.c"
	}
#line 197 "../src/puzzle.vala"
	_tmp11_ = self->map;
#line 197 "../src/puzzle.vala"
	_tmp11__length1 = self->map_length1;
#line 197 "../src/puzzle.vala"
	_tmp12_ = self->priv->_width;
#line 197 "../src/puzzle.vala"
	_tmp13_ = _tmp11_[(((guint16) x) + 1) + ((((guint16) y) - 1) * (((guint16) _tmp12_) + 2))];
#line 197 "../src/puzzle.vala"
	if (_tmp13_ == c) {
#line 198 "../src/puzzle.vala"
		nr += (guint8) 4;
#line 402 "puzzle.c"
	}
#line 199 "../src/puzzle.vala"
	_tmp14_ = self->map;
#line 199 "../src/puzzle.vala"
	_tmp14__length1 = self->map_length1;
#line 199 "../src/puzzle.vala"
	_tmp15_ = self->priv->_width;
#line 199 "../src/puzzle.vala"
	_tmp16_ = _tmp14_[(((guint16) x) - 1) + (((guint16) y) * (((guint16) _tmp15_) + 2))];
#line 199 "../src/puzzle.vala"
	if (_tmp16_ == c) {
#line 200 "../src/puzzle.vala"
		nr += (guint8) 8;
#line 416 "puzzle.c"
	}
#line 201 "../src/puzzle.vala"
	_tmp17_ = self->map;
#line 201 "../src/puzzle.vala"
	_tmp17__length1 = self->map_length1;
#line 201 "../src/puzzle.vala"
	_tmp18_ = self->priv->_width;
#line 201 "../src/puzzle.vala"
	_tmp19_ = _tmp17_[(((guint16) x) + 1) + (((guint16) y) * (((guint16) _tmp18_) + 2))];
#line 201 "../src/puzzle.vala"
	if (_tmp19_ == c) {
#line 202 "../src/puzzle.vala"
		nr += (guint8) 16;
#line 430 "puzzle.c"
	}
#line 203 "../src/puzzle.vala"
	_tmp20_ = self->map;
#line 203 "../src/puzzle.vala"
	_tmp20__length1 = self->map_length1;
#line 203 "../src/puzzle.vala"
	_tmp21_ = self->priv->_width;
#line 203 "../src/puzzle.vala"
	_tmp22_ = _tmp20_[(((guint16) x) - 1) + ((((guint16) y) + 1) * (((guint16) _tmp21_) + 2))];
#line 203 "../src/puzzle.vala"
	if (_tmp22_ == c) {
#line 204 "../src/puzzle.vala"
		nr += (guint8) 32;
#line 444 "puzzle.c"
	}
#line 205 "../src/puzzle.vala"
	_tmp23_ = self->map;
#line 205 "../src/puzzle.vala"
	_tmp23__length1 = self->map_length1;
#line 205 "../src/puzzle.vala"
	_tmp24_ = self->priv->_width;
#line 205 "../src/puzzle.vala"
	_tmp25_ = _tmp23_[((guint16) x) + ((((guint16) y) + 1) * (((guint16) _tmp24_) + 2))];
#line 205 "../src/puzzle.vala"
	if (_tmp25_ == c) {
#line 206 "../src/puzzle.vala"
		nr += (guint8) 64;
#line 458 "puzzle.c"
	}
#line 207 "../src/puzzle.vala"
	_tmp26_ = self->map;
#line 207 "../src/puzzle.vala"
	_tmp26__length1 = self->map_length1;
#line 207 "../src/puzzle.vala"
	_tmp27_ = self->priv->_width;
#line 207 "../src/puzzle.vala"
	_tmp28_ = _tmp26_[(((guint16) x) + 1) + ((((guint16) y) + 1) * (((guint16) _tmp27_) + 2))];
#line 207 "../src/puzzle.vala"
	if (_tmp28_ == c) {
#line 208 "../src/puzzle.vala"
		nr += (guint8) 128;
#line 472 "puzzle.c"
	}
	{
		guint8 i = 0U;
#line 210 "../src/puzzle.vala"
		i = (guint8) 0;
#line 478 "puzzle.c"
		{
			gboolean _tmp29_ = FALSE;
#line 210 "../src/puzzle.vala"
			_tmp29_ = TRUE;
#line 210 "../src/puzzle.vala"
			while (TRUE) {
#line 485 "puzzle.c"
				guint8 _tmp30_;
#line 210 "../src/puzzle.vala"
				if (!_tmp29_) {
#line 210 "../src/puzzle.vala"
					i += (guint8) 2;
#line 491 "puzzle.c"
				}
#line 210 "../src/puzzle.vala"
				_tmp29_ = FALSE;
#line 210 "../src/puzzle.vala"
				if (!(((gint) i) < (self->priv->image_map_length * 2))) {
#line 210 "../src/puzzle.vala"
					break;
#line 499 "puzzle.c"
				}
#line 212 "../src/puzzle.vala"
				_tmp30_ = PUZZLE_image_map[i];
#line 212 "../src/puzzle.vala"
				if (nr == _tmp30_) {
#line 505 "puzzle.c"
					guint8 _tmp31_;
#line 213 "../src/puzzle.vala"
					_tmp31_ = PUZZLE_image_map[i + 1];
#line 213 "../src/puzzle.vala"
					result = (gint) _tmp31_;
#line 213 "../src/puzzle.vala"
					return result;
#line 513 "puzzle.c"
				}
			}
		}
	}
#line 215 "../src/puzzle.vala"
	g_assert_not_reached ();
#line 520 "puzzle.c"
}

gboolean
puzzle_game_over (Puzzle* self)
{
	gboolean over = FALSE;
	gboolean result;
#line 218 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 220 "../src/puzzle.vala"
	over = TRUE;
#line 532 "puzzle.c"
	{
		guint8 y = 0U;
#line 221 "../src/puzzle.vala"
		y = (guint8) 0;
#line 537 "puzzle.c"
		{
			gboolean _tmp0_ = FALSE;
#line 221 "../src/puzzle.vala"
			_tmp0_ = TRUE;
#line 221 "../src/puzzle.vala"
			while (TRUE) {
#line 544 "puzzle.c"
				guint8 _tmp2_;
#line 221 "../src/puzzle.vala"
				if (!_tmp0_) {
#line 548 "puzzle.c"
					guint8 _tmp1_;
#line 221 "../src/puzzle.vala"
					_tmp1_ = y;
#line 221 "../src/puzzle.vala"
					y = _tmp1_ + 1;
#line 554 "puzzle.c"
				}
#line 221 "../src/puzzle.vala"
				_tmp0_ = FALSE;
#line 221 "../src/puzzle.vala"
				_tmp2_ = self->priv->_height;
#line 221 "../src/puzzle.vala"
				if (!(y < _tmp2_)) {
#line 221 "../src/puzzle.vala"
					break;
#line 564 "puzzle.c"
				}
				{
					guint8 x = 0U;
#line 222 "../src/puzzle.vala"
					x = (guint8) 0;
#line 570 "puzzle.c"
					{
						gboolean _tmp3_ = FALSE;
#line 222 "../src/puzzle.vala"
						_tmp3_ = TRUE;
#line 222 "../src/puzzle.vala"
						while (TRUE) {
#line 577 "puzzle.c"
							guint8 _tmp5_;
							gboolean _tmp6_ = FALSE;
							gchar* _tmp7_;
							gint _tmp7__length1;
#line 222 "../src/puzzle.vala"
							if (!_tmp3_) {
#line 584 "puzzle.c"
								guint8 _tmp4_;
#line 222 "../src/puzzle.vala"
								_tmp4_ = x;
#line 222 "../src/puzzle.vala"
								x = _tmp4_ + 1;
#line 590 "puzzle.c"
							}
#line 222 "../src/puzzle.vala"
							_tmp3_ = FALSE;
#line 222 "../src/puzzle.vala"
							_tmp5_ = self->priv->_width;
#line 222 "../src/puzzle.vala"
							if (!(x < _tmp5_)) {
#line 222 "../src/puzzle.vala"
								break;
#line 600 "puzzle.c"
							}
#line 223 "../src/puzzle.vala"
							_tmp7_ = self->map;
#line 223 "../src/puzzle.vala"
							_tmp7__length1 = self->map_length1;
#line 223 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, _tmp7_, (gint) _tmp7__length1, x, y) == '*') {
#line 608 "puzzle.c"
								gchar* _tmp8_;
								gint _tmp8__length1;
#line 223 "../src/puzzle.vala"
								_tmp8_ = self->orig_map;
#line 223 "../src/puzzle.vala"
								_tmp8__length1 = self->orig_map_length1;
#line 223 "../src/puzzle.vala"
								_tmp6_ = puzzle_get_piece_id (self, _tmp8_, (gint) _tmp8__length1, x, y) != '.';
#line 617 "puzzle.c"
							} else {
#line 223 "../src/puzzle.vala"
								_tmp6_ = FALSE;
#line 621 "puzzle.c"
							}
#line 223 "../src/puzzle.vala"
							if (_tmp6_) {
#line 224 "../src/puzzle.vala"
								over = FALSE;
#line 627 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
#line 225 "../src/puzzle.vala"
	result = over;
#line 225 "../src/puzzle.vala"
	return result;
#line 639 "puzzle.c"
}

gboolean
puzzle_mapcmp (Puzzle* self,
               gchar* m1,
               gint m1_length1,
               gchar* m2,
               gint m2_length1)
{
	gboolean result;
#line 228 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 652 "puzzle.c"
	{
		guint8 y = 0U;
#line 230 "../src/puzzle.vala"
		y = (guint8) 0;
#line 657 "puzzle.c"
		{
			gboolean _tmp0_ = FALSE;
#line 230 "../src/puzzle.vala"
			_tmp0_ = TRUE;
#line 230 "../src/puzzle.vala"
			while (TRUE) {
#line 664 "puzzle.c"
				guint8 _tmp2_;
#line 230 "../src/puzzle.vala"
				if (!_tmp0_) {
#line 668 "puzzle.c"
					guint8 _tmp1_;
#line 230 "../src/puzzle.vala"
					_tmp1_ = y;
#line 230 "../src/puzzle.vala"
					y = _tmp1_ + 1;
#line 674 "puzzle.c"
				}
#line 230 "../src/puzzle.vala"
				_tmp0_ = FALSE;
#line 230 "../src/puzzle.vala"
				_tmp2_ = self->priv->_height;
#line 230 "../src/puzzle.vala"
				if (!(y < _tmp2_)) {
#line 230 "../src/puzzle.vala"
					break;
#line 684 "puzzle.c"
				}
				{
					guint8 x = 0U;
#line 231 "../src/puzzle.vala"
					x = (guint8) 0;
#line 690 "puzzle.c"
					{
						gboolean _tmp3_ = FALSE;
#line 231 "../src/puzzle.vala"
						_tmp3_ = TRUE;
#line 231 "../src/puzzle.vala"
						while (TRUE) {
#line 697 "puzzle.c"
							guint8 _tmp5_;
#line 231 "../src/puzzle.vala"
							if (!_tmp3_) {
#line 701 "puzzle.c"
								guint8 _tmp4_;
#line 231 "../src/puzzle.vala"
								_tmp4_ = x;
#line 231 "../src/puzzle.vala"
								x = _tmp4_ + 1;
#line 707 "puzzle.c"
							}
#line 231 "../src/puzzle.vala"
							_tmp3_ = FALSE;
#line 231 "../src/puzzle.vala"
							_tmp5_ = self->priv->_width;
#line 231 "../src/puzzle.vala"
							if (!(x < _tmp5_)) {
#line 231 "../src/puzzle.vala"
								break;
#line 717 "puzzle.c"
							}
#line 232 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, m1, (gint) m1_length1, x, y) != puzzle_get_piece_id (self, m2, (gint) m2_length1, x, y)) {
#line 233 "../src/puzzle.vala"
								result = TRUE;
#line 233 "../src/puzzle.vala"
								return result;
#line 725 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
#line 234 "../src/puzzle.vala"
	result = FALSE;
#line 234 "../src/puzzle.vala"
	return result;
#line 737 "puzzle.c"
}

inline gboolean
puzzle_is_static_tile (gchar id)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 239 "../src/puzzle.vala"
	if (id == '#') {
#line 239 "../src/puzzle.vala"
		_tmp2_ = TRUE;
#line 751 "puzzle.c"
	} else {
#line 239 "../src/puzzle.vala"
		_tmp2_ = id == '.';
#line 755 "puzzle.c"
	}
#line 239 "../src/puzzle.vala"
	if (_tmp2_) {
#line 239 "../src/puzzle.vala"
		_tmp1_ = TRUE;
#line 761 "puzzle.c"
	} else {
#line 239 "../src/puzzle.vala"
		_tmp1_ = id == ' ';
#line 765 "puzzle.c"
	}
#line 239 "../src/puzzle.vala"
	if (_tmp1_) {
#line 239 "../src/puzzle.vala"
		_tmp0_ = TRUE;
#line 771 "puzzle.c"
	} else {
#line 239 "../src/puzzle.vala"
		_tmp0_ = id == '-';
#line 775 "puzzle.c"
	}
#line 239 "../src/puzzle.vala"
	if (_tmp0_) {
#line 240 "../src/puzzle.vala"
		result = TRUE;
#line 240 "../src/puzzle.vala"
		return result;
#line 783 "puzzle.c"
	} else {
#line 242 "../src/puzzle.vala"
		result = FALSE;
#line 242 "../src/puzzle.vala"
		return result;
#line 789 "puzzle.c"
	}
}

gboolean
puzzle_move_piece (Puzzle* self,
                   gchar id,
                   guint8 x1,
                   guint8 y1,
                   guint8 x2,
                   guint8 y2)
{
	gboolean return_value = FALSE;
	gchar* _tmp0_;
	gint _tmp0__length1;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 245 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 247 "../src/puzzle.vala"
	return_value = FALSE;
#line 249 "../src/puzzle.vala"
	if (puzzle_is_static_tile (id)) {
#line 250 "../src/puzzle.vala"
		result = FALSE;
#line 250 "../src/puzzle.vala"
		return result;
#line 817 "puzzle.c"
	}
#line 252 "../src/puzzle.vala"
	_tmp0_ = self->map;
#line 252 "../src/puzzle.vala"
	_tmp0__length1 = self->map_length1;
#line 252 "../src/puzzle.vala"
	if (puzzle_get_piece_id (self, _tmp0_, (gint) _tmp0__length1, x2, y2) == id) {
#line 253 "../src/puzzle.vala"
		return_value = TRUE;
#line 827 "puzzle.c"
	}
#line 255 "../src/puzzle.vala"
	if (y1 == y2) {
#line 255 "../src/puzzle.vala"
		_tmp2_ = abs (((gint) x1) - ((gint) x2)) == 1;
#line 833 "puzzle.c"
	} else {
#line 255 "../src/puzzle.vala"
		_tmp2_ = FALSE;
#line 837 "puzzle.c"
	}
#line 255 "../src/puzzle.vala"
	if (_tmp2_) {
#line 255 "../src/puzzle.vala"
		_tmp1_ = TRUE;
#line 843 "puzzle.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 255 "../src/puzzle.vala"
		if (x1 == x2) {
#line 255 "../src/puzzle.vala"
			_tmp3_ = abs (((gint) y1) - ((gint) y2)) == 1;
#line 850 "puzzle.c"
		} else {
#line 255 "../src/puzzle.vala"
			_tmp3_ = FALSE;
#line 854 "puzzle.c"
		}
#line 255 "../src/puzzle.vala"
		_tmp1_ = _tmp3_;
#line 858 "puzzle.c"
	}
#line 255 "../src/puzzle.vala"
	if (!_tmp1_) {
#line 256 "../src/puzzle.vala"
		result = FALSE;
#line 256 "../src/puzzle.vala"
		return result;
#line 866 "puzzle.c"
	}
#line 258 "../src/puzzle.vala"
	if (abs (((gint) y1) - ((gint) y2)) == 1) {
#line 260 "../src/puzzle.vala"
		if (y1 < y2) {
#line 262 "../src/puzzle.vala"
			if (puzzle_check_valid_move (self, id, (gint8) 0, (gint8) 1)) {
#line 263 "../src/puzzle.vala"
				result = puzzle_do_move_piece (self, id, (gint8) 0, (gint8) 1);
#line 263 "../src/puzzle.vala"
				return result;
#line 878 "puzzle.c"
			}
		} else {
#line 265 "../src/puzzle.vala"
			if (y1 > y2) {
#line 267 "../src/puzzle.vala"
				if (puzzle_check_valid_move (self, id, (gint8) 0, (gint8) -1)) {
#line 268 "../src/puzzle.vala"
					result = puzzle_do_move_piece (self, id, (gint8) 0, (gint8) -1);
#line 268 "../src/puzzle.vala"
					return result;
#line 889 "puzzle.c"
				}
			}
		}
	}
#line 272 "../src/puzzle.vala"
	if (abs (((gint) x1) - ((gint) x2)) == 1) {
#line 274 "../src/puzzle.vala"
		if (x1 < x2) {
#line 276 "../src/puzzle.vala"
			if (puzzle_check_valid_move (self, id, (gint8) 1, (gint8) 0)) {
#line 277 "../src/puzzle.vala"
				result = puzzle_do_move_piece (self, id, (gint8) 1, (gint8) 0);
#line 277 "../src/puzzle.vala"
				return result;
#line 904 "puzzle.c"
			}
		} else {
#line 279 "../src/puzzle.vala"
			if (x1 > x2) {
#line 281 "../src/puzzle.vala"
				if (puzzle_check_valid_move (self, id, (gint8) -1, (gint8) 0)) {
#line 282 "../src/puzzle.vala"
					result = puzzle_do_move_piece (self, id, (gint8) -1, (gint8) 0);
#line 282 "../src/puzzle.vala"
					return result;
#line 915 "puzzle.c"
				}
			}
		}
	}
#line 286 "../src/puzzle.vala"
	result = return_value;
#line 286 "../src/puzzle.vala"
	return result;
#line 924 "puzzle.c"
}

gboolean
puzzle_can_be_moved (Puzzle* self,
                     gchar id)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 289 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 291 "../src/puzzle.vala"
	if (puzzle_is_static_tile (id)) {
#line 292 "../src/puzzle.vala"
		result = FALSE;
#line 292 "../src/puzzle.vala"
		return result;
#line 943 "puzzle.c"
	}
#line 294 "../src/puzzle.vala"
	if (puzzle_check_valid_move (self, id, (gint8) 0, (gint8) 1)) {
#line 294 "../src/puzzle.vala"
		_tmp2_ = TRUE;
#line 949 "puzzle.c"
	} else {
#line 295 "../src/puzzle.vala"
		_tmp2_ = puzzle_check_valid_move (self, id, (gint8) 0, (gint8) -1);
#line 953 "puzzle.c"
	}
#line 294 "../src/puzzle.vala"
	if (_tmp2_) {
#line 294 "../src/puzzle.vala"
		_tmp1_ = TRUE;
#line 959 "puzzle.c"
	} else {
#line 296 "../src/puzzle.vala"
		_tmp1_ = puzzle_check_valid_move (self, id, (gint8) 1, (gint8) 0);
#line 963 "puzzle.c"
	}
#line 294 "../src/puzzle.vala"
	if (_tmp1_) {
#line 294 "../src/puzzle.vala"
		_tmp0_ = TRUE;
#line 969 "puzzle.c"
	} else {
#line 297 "../src/puzzle.vala"
		_tmp0_ = puzzle_check_valid_move (self, id, (gint8) -1, (gint8) 0);
#line 973 "puzzle.c"
	}
#line 294 "../src/puzzle.vala"
	result = _tmp0_;
#line 294 "../src/puzzle.vala"
	return result;
#line 979 "puzzle.c"
}

static gboolean
puzzle_check_valid_move (Puzzle* self,
                         gchar id,
                         gint8 dx,
                         gint8 dy)
{
	gboolean result;
#line 300 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 991 "puzzle.c"
	{
		gint8 y = 0;
#line 302 "../src/puzzle.vala"
		y = (gint8) 0;
#line 996 "puzzle.c"
		{
			gboolean _tmp0_ = FALSE;
#line 302 "../src/puzzle.vala"
			_tmp0_ = TRUE;
#line 302 "../src/puzzle.vala"
			while (TRUE) {
#line 1003 "puzzle.c"
				guint8 _tmp2_;
#line 302 "../src/puzzle.vala"
				if (!_tmp0_) {
#line 1007 "puzzle.c"
					gint8 _tmp1_;
#line 302 "../src/puzzle.vala"
					_tmp1_ = y;
#line 302 "../src/puzzle.vala"
					y = _tmp1_ + 1;
#line 1013 "puzzle.c"
				}
#line 302 "../src/puzzle.vala"
				_tmp0_ = FALSE;
#line 302 "../src/puzzle.vala"
				_tmp2_ = self->priv->_height;
#line 302 "../src/puzzle.vala"
				if (!(((guint8) y) < _tmp2_)) {
#line 302 "../src/puzzle.vala"
					break;
#line 1023 "puzzle.c"
				}
				{
					gint8 x = 0;
#line 304 "../src/puzzle.vala"
					x = (gint8) 0;
#line 1029 "puzzle.c"
					{
						gboolean _tmp3_ = FALSE;
#line 304 "../src/puzzle.vala"
						_tmp3_ = TRUE;
#line 304 "../src/puzzle.vala"
						while (TRUE) {
#line 1036 "puzzle.c"
							guint8 _tmp5_;
							gchar* _tmp6_;
							gint _tmp6__length1;
#line 304 "../src/puzzle.vala"
							if (!_tmp3_) {
#line 1042 "puzzle.c"
								gint8 _tmp4_;
#line 304 "../src/puzzle.vala"
								_tmp4_ = x;
#line 304 "../src/puzzle.vala"
								x = _tmp4_ + 1;
#line 1048 "puzzle.c"
							}
#line 304 "../src/puzzle.vala"
							_tmp3_ = FALSE;
#line 304 "../src/puzzle.vala"
							_tmp5_ = self->priv->_width;
#line 304 "../src/puzzle.vala"
							if (!(((guint8) x) < _tmp5_)) {
#line 304 "../src/puzzle.vala"
								break;
#line 1058 "puzzle.c"
							}
#line 306 "../src/puzzle.vala"
							_tmp6_ = self->map;
#line 306 "../src/puzzle.vala"
							_tmp6__length1 = self->map_length1;
#line 306 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, _tmp6_, (gint) _tmp6__length1, (guint8) x, (guint8) y) == id) {
#line 1066 "puzzle.c"
								gchar z = '\0';
								gchar* _tmp7_;
								gint _tmp7__length1;
								gboolean _tmp8_ = FALSE;
								gboolean _tmp9_ = FALSE;
								gboolean _tmp10_ = FALSE;
#line 308 "../src/puzzle.vala"
								_tmp7_ = self->map;
#line 308 "../src/puzzle.vala"
								_tmp7__length1 = self->map_length1;
#line 308 "../src/puzzle.vala"
								z = puzzle_get_piece_id (self, _tmp7_, (gint) _tmp7__length1, (guint8) (x + dx), (guint8) (y + dy));
#line 309 "../src/puzzle.vala"
								if (z == ' ') {
#line 309 "../src/puzzle.vala"
									_tmp10_ = TRUE;
#line 1083 "puzzle.c"
								} else {
#line 309 "../src/puzzle.vala"
									_tmp10_ = z == '.';
#line 1087 "puzzle.c"
								}
#line 309 "../src/puzzle.vala"
								if (_tmp10_) {
#line 309 "../src/puzzle.vala"
									_tmp9_ = TRUE;
#line 1093 "puzzle.c"
								} else {
#line 309 "../src/puzzle.vala"
									_tmp9_ = z == id;
#line 1097 "puzzle.c"
								}
#line 309 "../src/puzzle.vala"
								if (_tmp9_) {
#line 309 "../src/puzzle.vala"
									_tmp8_ = TRUE;
#line 1103 "puzzle.c"
								} else {
									gboolean _tmp11_ = FALSE;
#line 309 "../src/puzzle.vala"
									if (id == '*') {
#line 309 "../src/puzzle.vala"
										_tmp11_ = z == '-';
#line 1110 "puzzle.c"
									} else {
#line 309 "../src/puzzle.vala"
										_tmp11_ = FALSE;
#line 1114 "puzzle.c"
									}
#line 309 "../src/puzzle.vala"
									_tmp8_ = _tmp11_;
#line 1118 "puzzle.c"
								}
#line 309 "../src/puzzle.vala"
								if (!_tmp8_) {
#line 310 "../src/puzzle.vala"
									result = FALSE;
#line 310 "../src/puzzle.vala"
									return result;
#line 1126 "puzzle.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 315 "../src/puzzle.vala"
	result = TRUE;
#line 315 "../src/puzzle.vala"
	return result;
#line 1139 "puzzle.c"
}

static gchar*
_vala_array_dup1 (gchar* self,
                  gssize length)
{
#line 320 "../src/puzzle.vala"
	if (length > 0) {
#line 320 "../src/puzzle.vala"
		return _vala_memdup2 (self, length * sizeof (gchar));
#line 1150 "puzzle.c"
	}
#line 320 "../src/puzzle.vala"
	return NULL;
#line 1154 "puzzle.c"
}

static gchar*
_vala_array_dup2 (gchar* self,
                  gssize length)
{
#line 354 "../src/puzzle.vala"
	if (length > 0) {
#line 354 "../src/puzzle.vala"
		return _vala_memdup2 (self, length * sizeof (gchar));
#line 1165 "puzzle.c"
	}
#line 354 "../src/puzzle.vala"
	return NULL;
#line 1169 "puzzle.c"
}

static gboolean
puzzle_do_move_piece (Puzzle* self,
                      gchar id,
                      gint8 dx,
                      gint8 dy)
{
	gchar* tmpmap = NULL;
	gchar* _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gint _tmp1__length1;
	gint tmpmap_length1;
	gint _tmpmap_size_;
	gchar* _tmp32_;
	gint _tmp32__length1;
	gchar* _tmp33_;
	gint _tmp33__length1;
	gboolean result;
#line 318 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 320 "../src/puzzle.vala"
	_tmp0_ = self->map;
#line 320 "../src/puzzle.vala"
	_tmp0__length1 = self->map_length1;
#line 320 "../src/puzzle.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 320 "../src/puzzle.vala"
	_tmp1__length1 = _tmp0__length1;
#line 320 "../src/puzzle.vala"
	tmpmap = _tmp1_;
#line 320 "../src/puzzle.vala"
	tmpmap_length1 = _tmp1__length1;
#line 320 "../src/puzzle.vala"
	_tmpmap_size_ = tmpmap_length1;
#line 1206 "puzzle.c"
	{
		guint8 y = 0U;
#line 323 "../src/puzzle.vala"
		y = (guint8) 0;
#line 1211 "puzzle.c"
		{
			gboolean _tmp2_ = FALSE;
#line 323 "../src/puzzle.vala"
			_tmp2_ = TRUE;
#line 323 "../src/puzzle.vala"
			while (TRUE) {
#line 1218 "puzzle.c"
				guint8 _tmp4_;
#line 323 "../src/puzzle.vala"
				if (!_tmp2_) {
#line 1222 "puzzle.c"
					guint8 _tmp3_;
#line 323 "../src/puzzle.vala"
					_tmp3_ = y;
#line 323 "../src/puzzle.vala"
					y = _tmp3_ + 1;
#line 1228 "puzzle.c"
				}
#line 323 "../src/puzzle.vala"
				_tmp2_ = FALSE;
#line 323 "../src/puzzle.vala"
				_tmp4_ = self->priv->_height;
#line 323 "../src/puzzle.vala"
				if (!(y < _tmp4_)) {
#line 323 "../src/puzzle.vala"
					break;
#line 1238 "puzzle.c"
				}
				{
					guint8 x = 0U;
#line 324 "../src/puzzle.vala"
					x = (guint8) 0;
#line 1244 "puzzle.c"
					{
						gboolean _tmp5_ = FALSE;
#line 324 "../src/puzzle.vala"
						_tmp5_ = TRUE;
#line 324 "../src/puzzle.vala"
						while (TRUE) {
#line 1251 "puzzle.c"
							guint8 _tmp7_;
							gchar* _tmp8_;
							gint _tmp8__length1;
#line 324 "../src/puzzle.vala"
							if (!_tmp5_) {
#line 1257 "puzzle.c"
								guint8 _tmp6_;
#line 324 "../src/puzzle.vala"
								_tmp6_ = x;
#line 324 "../src/puzzle.vala"
								x = _tmp6_ + 1;
#line 1263 "puzzle.c"
							}
#line 324 "../src/puzzle.vala"
							_tmp5_ = FALSE;
#line 324 "../src/puzzle.vala"
							_tmp7_ = self->priv->_width;
#line 324 "../src/puzzle.vala"
							if (!(x < _tmp7_)) {
#line 324 "../src/puzzle.vala"
								break;
#line 1273 "puzzle.c"
							}
#line 325 "../src/puzzle.vala"
							_tmp8_ = tmpmap;
#line 325 "../src/puzzle.vala"
							_tmp8__length1 = tmpmap_length1;
#line 325 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, _tmp8_, (gint) _tmp8__length1, x, y) == id) {
#line 1281 "puzzle.c"
								gchar* _tmp9_;
								gint _tmp9__length1;
#line 326 "../src/puzzle.vala"
								_tmp9_ = tmpmap;
#line 326 "../src/puzzle.vala"
								_tmp9__length1 = tmpmap_length1;
#line 326 "../src/puzzle.vala"
								puzzle_set_piece_id (self, _tmp9_, (gint) _tmp9__length1, x, y, ' ');
#line 1290 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
	{
		gint8 y = 0;
#line 328 "../src/puzzle.vala"
		y = (gint8) 0;
#line 1302 "puzzle.c"
		{
			gboolean _tmp10_ = FALSE;
#line 328 "../src/puzzle.vala"
			_tmp10_ = TRUE;
#line 328 "../src/puzzle.vala"
			while (TRUE) {
#line 1309 "puzzle.c"
				guint8 _tmp12_;
#line 328 "../src/puzzle.vala"
				if (!_tmp10_) {
#line 1313 "puzzle.c"
					gint8 _tmp11_;
#line 328 "../src/puzzle.vala"
					_tmp11_ = y;
#line 328 "../src/puzzle.vala"
					y = _tmp11_ + 1;
#line 1319 "puzzle.c"
				}
#line 328 "../src/puzzle.vala"
				_tmp10_ = FALSE;
#line 328 "../src/puzzle.vala"
				_tmp12_ = self->priv->_height;
#line 328 "../src/puzzle.vala"
				if (!(((guint8) y) < _tmp12_)) {
#line 328 "../src/puzzle.vala"
					break;
#line 1329 "puzzle.c"
				}
				{
					gint8 x = 0;
#line 329 "../src/puzzle.vala"
					x = (gint8) 0;
#line 1335 "puzzle.c"
					{
						gboolean _tmp13_ = FALSE;
#line 329 "../src/puzzle.vala"
						_tmp13_ = TRUE;
#line 329 "../src/puzzle.vala"
						while (TRUE) {
#line 1342 "puzzle.c"
							guint8 _tmp15_;
							gchar* _tmp16_;
							gint _tmp16__length1;
#line 329 "../src/puzzle.vala"
							if (!_tmp13_) {
#line 1348 "puzzle.c"
								gint8 _tmp14_;
#line 329 "../src/puzzle.vala"
								_tmp14_ = x;
#line 329 "../src/puzzle.vala"
								x = _tmp14_ + 1;
#line 1354 "puzzle.c"
							}
#line 329 "../src/puzzle.vala"
							_tmp13_ = FALSE;
#line 329 "../src/puzzle.vala"
							_tmp15_ = self->priv->_width;
#line 329 "../src/puzzle.vala"
							if (!(((guint8) x) < _tmp15_)) {
#line 329 "../src/puzzle.vala"
								break;
#line 1364 "puzzle.c"
							}
#line 330 "../src/puzzle.vala"
							_tmp16_ = self->map;
#line 330 "../src/puzzle.vala"
							_tmp16__length1 = self->map_length1;
#line 330 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, _tmp16_, (gint) _tmp16__length1, (guint8) x, (guint8) y) == id) {
#line 1372 "puzzle.c"
								gchar* _tmp17_;
								gint _tmp17__length1;
#line 331 "../src/puzzle.vala"
								_tmp17_ = tmpmap;
#line 331 "../src/puzzle.vala"
								_tmp17__length1 = tmpmap_length1;
#line 331 "../src/puzzle.vala"
								puzzle_set_piece_id (self, _tmp17_, (gint) _tmp17__length1, (guint8) (x + dx), (guint8) (y + dy), id);
#line 1381 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
	{
		guint8 y = 0U;
#line 334 "../src/puzzle.vala"
		y = (guint8) 0;
#line 1393 "puzzle.c"
		{
			gboolean _tmp18_ = FALSE;
#line 334 "../src/puzzle.vala"
			_tmp18_ = TRUE;
#line 334 "../src/puzzle.vala"
			while (TRUE) {
#line 1400 "puzzle.c"
				guint8 _tmp20_;
#line 334 "../src/puzzle.vala"
				if (!_tmp18_) {
#line 1404 "puzzle.c"
					guint8 _tmp19_;
#line 334 "../src/puzzle.vala"
					_tmp19_ = y;
#line 334 "../src/puzzle.vala"
					y = _tmp19_ + 1;
#line 1410 "puzzle.c"
				}
#line 334 "../src/puzzle.vala"
				_tmp18_ = FALSE;
#line 334 "../src/puzzle.vala"
				_tmp20_ = self->priv->_height;
#line 334 "../src/puzzle.vala"
				if (!(y < _tmp20_)) {
#line 334 "../src/puzzle.vala"
					break;
#line 1420 "puzzle.c"
				}
				{
					guint8 x = 0U;
#line 336 "../src/puzzle.vala"
					x = (guint8) 0;
#line 1426 "puzzle.c"
					{
						gboolean _tmp21_ = FALSE;
#line 336 "../src/puzzle.vala"
						_tmp21_ = TRUE;
#line 336 "../src/puzzle.vala"
						while (TRUE) {
#line 1433 "puzzle.c"
							guint8 _tmp23_;
							gboolean _tmp24_ = FALSE;
							gchar* _tmp25_;
							gint _tmp25__length1;
							gboolean _tmp28_ = FALSE;
							gchar* _tmp29_;
							gint _tmp29__length1;
#line 336 "../src/puzzle.vala"
							if (!_tmp21_) {
#line 1443 "puzzle.c"
								guint8 _tmp22_;
#line 336 "../src/puzzle.vala"
								_tmp22_ = x;
#line 336 "../src/puzzle.vala"
								x = _tmp22_ + 1;
#line 1449 "puzzle.c"
							}
#line 336 "../src/puzzle.vala"
							_tmp21_ = FALSE;
#line 336 "../src/puzzle.vala"
							_tmp23_ = self->priv->_width;
#line 336 "../src/puzzle.vala"
							if (!(x < _tmp23_)) {
#line 336 "../src/puzzle.vala"
								break;
#line 1459 "puzzle.c"
							}
#line 338 "../src/puzzle.vala"
							_tmp25_ = tmpmap;
#line 338 "../src/puzzle.vala"
							_tmp25__length1 = tmpmap_length1;
#line 338 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, _tmp25_, (gint) _tmp25__length1, x, y) == ' ') {
#line 1467 "puzzle.c"
								gchar* _tmp26_;
								gint _tmp26__length1;
#line 338 "../src/puzzle.vala"
								_tmp26_ = self->orig_map;
#line 338 "../src/puzzle.vala"
								_tmp26__length1 = self->orig_map_length1;
#line 338 "../src/puzzle.vala"
								_tmp24_ = puzzle_get_piece_id (self, _tmp26_, (gint) _tmp26__length1, x, y) == '.';
#line 1476 "puzzle.c"
							} else {
#line 338 "../src/puzzle.vala"
								_tmp24_ = FALSE;
#line 1480 "puzzle.c"
							}
#line 338 "../src/puzzle.vala"
							if (_tmp24_) {
#line 1484 "puzzle.c"
								gchar* _tmp27_;
								gint _tmp27__length1;
#line 339 "../src/puzzle.vala"
								_tmp27_ = tmpmap;
#line 339 "../src/puzzle.vala"
								_tmp27__length1 = tmpmap_length1;
#line 339 "../src/puzzle.vala"
								puzzle_set_piece_id (self, _tmp27_, (gint) _tmp27__length1, x, y, '.');
#line 1493 "puzzle.c"
							}
#line 340 "../src/puzzle.vala"
							_tmp29_ = tmpmap;
#line 340 "../src/puzzle.vala"
							_tmp29__length1 = tmpmap_length1;
#line 340 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, _tmp29_, (gint) _tmp29__length1, x, y) == ' ') {
#line 1501 "puzzle.c"
								gchar* _tmp30_;
								gint _tmp30__length1;
#line 340 "../src/puzzle.vala"
								_tmp30_ = self->orig_map;
#line 340 "../src/puzzle.vala"
								_tmp30__length1 = self->orig_map_length1;
#line 340 "../src/puzzle.vala"
								_tmp28_ = puzzle_get_piece_id (self, _tmp30_, (gint) _tmp30__length1, x, y) == '-';
#line 1510 "puzzle.c"
							} else {
#line 340 "../src/puzzle.vala"
								_tmp28_ = FALSE;
#line 1514 "puzzle.c"
							}
#line 340 "../src/puzzle.vala"
							if (_tmp28_) {
#line 1518 "puzzle.c"
								gchar* _tmp31_;
								gint _tmp31__length1;
#line 341 "../src/puzzle.vala"
								_tmp31_ = tmpmap;
#line 341 "../src/puzzle.vala"
								_tmp31__length1 = tmpmap_length1;
#line 341 "../src/puzzle.vala"
								puzzle_set_piece_id (self, _tmp31_, (gint) _tmp31__length1, x, y, '-');
#line 1527 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
#line 352 "../src/puzzle.vala"
	g_signal_emit (self, puzzle_signals[PUZZLE_CHANGED_SIGNAL], 0);
#line 354 "../src/puzzle.vala"
	_tmp32_ = tmpmap;
#line 354 "../src/puzzle.vala"
	_tmp32__length1 = tmpmap_length1;
#line 354 "../src/puzzle.vala"
	_tmp33_ = (_tmp32_ != NULL) ? _vala_array_dup2 (_tmp32_, _tmp32__length1) : _tmp32_;
#line 354 "../src/puzzle.vala"
	_tmp33__length1 = _tmp32__length1;
#line 354 "../src/puzzle.vala"
	self->map = (g_free (self->map), NULL);
#line 354 "../src/puzzle.vala"
	self->map = _tmp33_;
#line 354 "../src/puzzle.vala"
	self->map_length1 = _tmp33__length1;
#line 354 "../src/puzzle.vala"
	self->_map_size_ = self->map_length1;
#line 356 "../src/puzzle.vala"
	result = TRUE;
#line 356 "../src/puzzle.vala"
	tmpmap = (g_free (tmpmap), NULL);
#line 356 "../src/puzzle.vala"
	return result;
#line 1559 "puzzle.c"
}

guint8
puzzle_get_width (Puzzle* self)
{
	guint8 result;
#line 130 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 130 "../src/puzzle.vala"
	result = self->priv->_width;
#line 130 "../src/puzzle.vala"
	return result;
#line 1572 "puzzle.c"
}

static void
puzzle_set_width (Puzzle* self,
                  guint8 value)
{
#line 130 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/puzzle.vala"
	self->priv->_width = value;
#line 1583 "puzzle.c"
}

guint8
puzzle_get_height (Puzzle* self)
{
	guint8 result;
#line 131 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 131 "../src/puzzle.vala"
	result = self->priv->_height;
#line 131 "../src/puzzle.vala"
	return result;
#line 1596 "puzzle.c"
}

static void
puzzle_set_height (Puzzle* self,
                   guint8 value)
{
#line 131 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/puzzle.vala"
	self->priv->_height = value;
#line 1607 "puzzle.c"
}

static const gchar*
puzzle_get_initial_map (Puzzle* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 132 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 132 "../src/puzzle.vala"
	_tmp0_ = self->priv->_initial_map;
#line 132 "../src/puzzle.vala"
	result = _tmp0_;
#line 132 "../src/puzzle.vala"
	return result;
#line 1623 "puzzle.c"
}

static void
puzzle_set_initial_map (Puzzle* self,
                        const gchar* value)
{
	gchar* _tmp0_;
#line 132 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/puzzle.vala"
	_tmp0_ = g_strdup (value);
#line 132 "../src/puzzle.vala"
	_g_free0 (self->priv->_initial_map);
#line 132 "../src/puzzle.vala"
	self->priv->_initial_map = _tmp0_;
#line 1639 "puzzle.c"
}

guint16
puzzle_get_moves (Puzzle* self)
{
	guint16 result;
#line 141 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 141 "../src/puzzle.vala"
	result = self->priv->_moves;
#line 141 "../src/puzzle.vala"
	return result;
#line 1652 "puzzle.c"
}

void
puzzle_set_moves (Puzzle* self,
                  guint16 value)
{
#line 141 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/puzzle.vala"
	self->priv->_moves = value;
#line 1663 "puzzle.c"
}

static gchar*
_vala_array_dup3 (gchar* self,
                  gssize length)
{
#line 154 "../src/puzzle.vala"
	if (length > 0) {
#line 154 "../src/puzzle.vala"
		return _vala_memdup2 (self, length * sizeof (gchar));
#line 1674 "puzzle.c"
	}
#line 154 "../src/puzzle.vala"
	return NULL;
#line 1678 "puzzle.c"
}

static gchar*
_vala_array_dup4 (gchar* self,
                  gssize length)
{
#line 155 "../src/puzzle.vala"
	if (length > 0) {
#line 155 "../src/puzzle.vala"
		return _vala_memdup2 (self, length * sizeof (gchar));
#line 1689 "puzzle.c"
	}
#line 155 "../src/puzzle.vala"
	return NULL;
#line 1693 "puzzle.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 1710 "puzzle.c"
}

static gchar*
_vala_array_dup5 (gchar* self,
                  gssize length)
{
#line 165 "../src/puzzle.vala"
	if (length > 0) {
#line 165 "../src/puzzle.vala"
		return _vala_memdup2 (self, length * sizeof (gchar));
#line 1721 "puzzle.c"
	}
#line 165 "../src/puzzle.vala"
	return NULL;
#line 1725 "puzzle.c"
}

static gchar*
_vala_array_dup6 (gchar* self,
                  gssize length)
{
#line 166 "../src/puzzle.vala"
	if (length > 0) {
#line 166 "../src/puzzle.vala"
		return _vala_memdup2 (self, length * sizeof (gchar));
#line 1736 "puzzle.c"
	}
#line 166 "../src/puzzle.vala"
	return NULL;
#line 1740 "puzzle.c"
}

static GObject *
puzzle_constructor (GType type,
                    guint n_construct_properties,
                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Puzzle * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gint _tmp6__length1;
	guint16 i = 0U;
	gchar* _tmp16_;
	gint _tmp16__length1;
	gchar* _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_;
	gint _tmp18__length1;
	gchar* _tmp19_;
	gint _tmp19__length1;
#line 151 "../src/puzzle.vala"
	parent_class = G_OBJECT_CLASS (puzzle_parent_class);
#line 151 "../src/puzzle.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 151 "../src/puzzle.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PUZZLE, Puzzle);
#line 153 "../src/puzzle.vala"
	_tmp0_ = self->priv->_width;
#line 153 "../src/puzzle.vala"
	_tmp1_ = self->priv->_height;
#line 153 "../src/puzzle.vala"
	_tmp2_ = g_new0 (gchar, (_tmp0_ + 2) * (_tmp1_ + 2));
#line 153 "../src/puzzle.vala"
	self->map = (g_free (self->map), NULL);
#line 153 "../src/puzzle.vala"
	self->map = _tmp2_;
#line 153 "../src/puzzle.vala"
	self->map_length1 = (_tmp0_ + 2) * (_tmp1_ + 2);
#line 153 "../src/puzzle.vala"
	self->_map_size_ = self->map_length1;
#line 154 "../src/puzzle.vala"
	_tmp3_ = self->map;
#line 154 "../src/puzzle.vala"
	_tmp3__length1 = self->map_length1;
#line 154 "../src/puzzle.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup3 (_tmp3_, _tmp3__length1) : _tmp3_;
#line 154 "../src/puzzle.vala"
	_tmp4__length1 = _tmp3__length1;
#line 154 "../src/puzzle.vala"
	self->move_map = (g_free (self->move_map), NULL);
#line 154 "../src/puzzle.vala"
	self->move_map = _tmp4_;
#line 154 "../src/puzzle.vala"
	self->move_map_length1 = _tmp4__length1;
#line 154 "../src/puzzle.vala"
	self->_move_map_size_ = self->move_map_length1;
#line 155 "../src/puzzle.vala"
	_tmp5_ = self->map;
#line 155 "../src/puzzle.vala"
	_tmp5__length1 = self->map_length1;
#line 155 "../src/puzzle.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup4 (_tmp5_, _tmp5__length1) : _tmp5_;
#line 155 "../src/puzzle.vala"
	_tmp6__length1 = _tmp5__length1;
#line 155 "../src/puzzle.vala"
	self->undomove_map = (g_free (self->undomove_map), NULL);
#line 155 "../src/puzzle.vala"
	self->undomove_map = _tmp6_;
#line 155 "../src/puzzle.vala"
	self->undomove_map_length1 = _tmp6__length1;
#line 155 "../src/puzzle.vala"
	self->_undomove_map_size_ = self->undomove_map_length1;
#line 157 "../src/puzzle.vala"
	i = (guint16) 0;
#line 1825 "puzzle.c"
	{
		guint8 y = 0U;
#line 158 "../src/puzzle.vala"
		y = (guint8) 0;
#line 1830 "puzzle.c"
		{
			gboolean _tmp7_ = FALSE;
#line 158 "../src/puzzle.vala"
			_tmp7_ = TRUE;
#line 158 "../src/puzzle.vala"
			while (TRUE) {
#line 1837 "puzzle.c"
				guint8 _tmp9_;
#line 158 "../src/puzzle.vala"
				if (!_tmp7_) {
#line 1841 "puzzle.c"
					guint8 _tmp8_;
#line 158 "../src/puzzle.vala"
					_tmp8_ = y;
#line 158 "../src/puzzle.vala"
					y = _tmp8_ + 1;
#line 1847 "puzzle.c"
				}
#line 158 "../src/puzzle.vala"
				_tmp7_ = FALSE;
#line 158 "../src/puzzle.vala"
				_tmp9_ = self->priv->_height;
#line 158 "../src/puzzle.vala"
				if (!(y < _tmp9_)) {
#line 158 "../src/puzzle.vala"
					break;
#line 1857 "puzzle.c"
				}
				{
					guint8 x = 0U;
#line 159 "../src/puzzle.vala"
					x = (guint8) 0;
#line 1863 "puzzle.c"
					{
						gboolean _tmp10_ = FALSE;
#line 159 "../src/puzzle.vala"
						_tmp10_ = TRUE;
#line 159 "../src/puzzle.vala"
						while (TRUE) {
#line 1870 "puzzle.c"
							guint8 _tmp12_;
							gchar* _tmp13_;
							gint _tmp13__length1;
							const gchar* _tmp14_;
							guint16 _tmp15_;
#line 159 "../src/puzzle.vala"
							if (!_tmp10_) {
#line 1878 "puzzle.c"
								guint8 _tmp11_;
#line 159 "../src/puzzle.vala"
								_tmp11_ = x;
#line 159 "../src/puzzle.vala"
								x = _tmp11_ + 1;
#line 1884 "puzzle.c"
							}
#line 159 "../src/puzzle.vala"
							_tmp10_ = FALSE;
#line 159 "../src/puzzle.vala"
							_tmp12_ = self->priv->_width;
#line 159 "../src/puzzle.vala"
							if (!(x < _tmp12_)) {
#line 159 "../src/puzzle.vala"
								break;
#line 1894 "puzzle.c"
							}
#line 161 "../src/puzzle.vala"
							_tmp13_ = self->map;
#line 161 "../src/puzzle.vala"
							_tmp13__length1 = self->map_length1;
#line 161 "../src/puzzle.vala"
							_tmp14_ = self->priv->_initial_map;
#line 161 "../src/puzzle.vala"
							puzzle_set_piece_id (self, _tmp13_, (gint) _tmp13__length1, x, y, string_get (_tmp14_, (glong) i));
#line 162 "../src/puzzle.vala"
							_tmp15_ = i;
#line 162 "../src/puzzle.vala"
							i = _tmp15_ + 1;
#line 1908 "puzzle.c"
						}
					}
				}
			}
		}
	}
#line 165 "../src/puzzle.vala"
	_tmp16_ = self->map;
#line 165 "../src/puzzle.vala"
	_tmp16__length1 = self->map_length1;
#line 165 "../src/puzzle.vala"
	_tmp17_ = (_tmp16_ != NULL) ? _vala_array_dup5 (_tmp16_, _tmp16__length1) : _tmp16_;
#line 165 "../src/puzzle.vala"
	_tmp17__length1 = _tmp16__length1;
#line 165 "../src/puzzle.vala"
	self->orig_map = (g_free (self->orig_map), NULL);
#line 165 "../src/puzzle.vala"
	self->orig_map = _tmp17_;
#line 165 "../src/puzzle.vala"
	self->orig_map_length1 = _tmp17__length1;
#line 165 "../src/puzzle.vala"
	self->_orig_map_size_ = self->orig_map_length1;
#line 166 "../src/puzzle.vala"
	_tmp18_ = self->map;
#line 166 "../src/puzzle.vala"
	_tmp18__length1 = self->map_length1;
#line 166 "../src/puzzle.vala"
	_tmp19_ = (_tmp18_ != NULL) ? _vala_array_dup6 (_tmp18_, _tmp18__length1) : _tmp18_;
#line 166 "../src/puzzle.vala"
	_tmp19__length1 = _tmp18__length1;
#line 166 "../src/puzzle.vala"
	self->lastmove_map = (g_free (self->lastmove_map), NULL);
#line 166 "../src/puzzle.vala"
	self->lastmove_map = _tmp19_;
#line 166 "../src/puzzle.vala"
	self->lastmove_map_length1 = _tmp19__length1;
#line 166 "../src/puzzle.vala"
	self->_lastmove_map_size_ = self->lastmove_map_length1;
#line 151 "../src/puzzle.vala"
	return obj;
#line 1949 "puzzle.c"
}

static void
puzzle_class_init (PuzzleClass * klass,
                   gpointer klass_data)
{
#line 20 "../src/puzzle.vala"
	puzzle_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/puzzle.vala"
	g_type_class_adjust_private_offset (klass, &Puzzle_private_offset);
#line 20 "../src/puzzle.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_puzzle_get_property;
#line 20 "../src/puzzle.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_puzzle_set_property;
#line 20 "../src/puzzle.vala"
	G_OBJECT_CLASS (klass)->constructor = puzzle_constructor;
#line 20 "../src/puzzle.vala"
	G_OBJECT_CLASS (klass)->finalize = puzzle_finalize;
#line 20 "../src/puzzle.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_WIDTH_PROPERTY, puzzle_properties[PUZZLE_WIDTH_PROPERTY] = g_param_spec_uchar ("width", "width", "width", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 20 "../src/puzzle.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_HEIGHT_PROPERTY, puzzle_properties[PUZZLE_HEIGHT_PROPERTY] = g_param_spec_uchar ("height", "height", "height", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 20 "../src/puzzle.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_INITIAL_MAP_PROPERTY, puzzle_properties[PUZZLE_INITIAL_MAP_PROPERTY] = g_param_spec_string ("initial-map", "initial-map", "initial-map", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 20 "../src/puzzle.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_MOVES_PROPERTY, puzzle_properties[PUZZLE_MOVES_PROPERTY] = g_param_spec_uint ("moves", "moves", "moves", 0, G_MAXUINT, (guint16) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 20 "../src/puzzle.vala"
	puzzle_signals[PUZZLE_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 20 "../src/puzzle.vala"
	puzzle_signals[PUZZLE_MOVED_SIGNAL] = g_signal_new ("moved", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1980 "puzzle.c"
}

static void
puzzle_instance_init (Puzzle * self,
                      gpointer klass)
{
#line 20 "../src/puzzle.vala"
	self->priv = puzzle_get_instance_private (self);
#line 128 "../src/puzzle.vala"
	self->priv->image_map_length = (guint8) 54;
#line 141 "../src/puzzle.vala"
	self->priv->_moves = (guint16) 0;
#line 1993 "puzzle.c"
}

static void
puzzle_finalize (GObject * obj)
{
	Puzzle * self;
#line 20 "../src/puzzle.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PUZZLE, Puzzle);
#line 132 "../src/puzzle.vala"
	_g_free0 (self->priv->_initial_map);
#line 135 "../src/puzzle.vala"
	self->map = (g_free (self->map), NULL);
#line 136 "../src/puzzle.vala"
	self->move_map = (g_free (self->move_map), NULL);
#line 137 "../src/puzzle.vala"
	self->orig_map = (g_free (self->orig_map), NULL);
#line 138 "../src/puzzle.vala"
	self->lastmove_map = (g_free (self->lastmove_map), NULL);
#line 139 "../src/puzzle.vala"
	self->undomove_map = (g_free (self->undomove_map), NULL);
#line 20 "../src/puzzle.vala"
	G_OBJECT_CLASS (puzzle_parent_class)->finalize (obj);
#line 2016 "puzzle.c"
}

static GType
puzzle_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PuzzleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) puzzle_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Puzzle), 0, (GInstanceInitFunc) puzzle_instance_init, NULL };
	GType puzzle_type_id;
	puzzle_type_id = g_type_register_static (G_TYPE_OBJECT, "Puzzle", &g_define_type_info, 0);
	Puzzle_private_offset = g_type_add_instance_private (puzzle_type_id, sizeof (PuzzlePrivate));
	return puzzle_type_id;
}

GType
puzzle_get_type (void)
{
	static volatile gsize puzzle_type_id__once = 0;
	if (g_once_init_enter (&puzzle_type_id__once)) {
		GType puzzle_type_id;
		puzzle_type_id = puzzle_get_type_once ();
		g_once_init_leave (&puzzle_type_id__once, puzzle_type_id);
	}
	return puzzle_type_id__once;
}

static void
_vala_puzzle_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Puzzle * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE, Puzzle);
#line 20 "../src/puzzle.vala"
	switch (property_id) {
#line 20 "../src/puzzle.vala"
		case PUZZLE_WIDTH_PROPERTY:
#line 20 "../src/puzzle.vala"
		g_value_set_uchar (value, puzzle_get_width (self));
#line 20 "../src/puzzle.vala"
		break;
#line 20 "../src/puzzle.vala"
		case PUZZLE_HEIGHT_PROPERTY:
#line 20 "../src/puzzle.vala"
		g_value_set_uchar (value, puzzle_get_height (self));
#line 20 "../src/puzzle.vala"
		break;
#line 20 "../src/puzzle.vala"
		case PUZZLE_INITIAL_MAP_PROPERTY:
#line 20 "../src/puzzle.vala"
		g_value_set_string (value, puzzle_get_initial_map (self));
#line 20 "../src/puzzle.vala"
		break;
#line 20 "../src/puzzle.vala"
		case PUZZLE_MOVES_PROPERTY:
#line 20 "../src/puzzle.vala"
		g_value_set_uint (value, puzzle_get_moves (self));
#line 20 "../src/puzzle.vala"
		break;
#line 2075 "puzzle.c"
		default:
#line 20 "../src/puzzle.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/puzzle.vala"
		break;
#line 2081 "puzzle.c"
	}
}

static void
_vala_puzzle_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Puzzle * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE, Puzzle);
#line 20 "../src/puzzle.vala"
	switch (property_id) {
#line 20 "../src/puzzle.vala"
		case PUZZLE_WIDTH_PROPERTY:
#line 20 "../src/puzzle.vala"
		puzzle_set_width (self, g_value_get_uchar (value));
#line 20 "../src/puzzle.vala"
		break;
#line 20 "../src/puzzle.vala"
		case PUZZLE_HEIGHT_PROPERTY:
#line 20 "../src/puzzle.vala"
		puzzle_set_height (self, g_value_get_uchar (value));
#line 20 "../src/puzzle.vala"
		break;
#line 20 "../src/puzzle.vala"
		case PUZZLE_INITIAL_MAP_PROPERTY:
#line 20 "../src/puzzle.vala"
		puzzle_set_initial_map (self, g_value_get_string (value));
#line 20 "../src/puzzle.vala"
		break;
#line 20 "../src/puzzle.vala"
		case PUZZLE_MOVES_PROPERTY:
#line 20 "../src/puzzle.vala"
		puzzle_set_moves (self, g_value_get_uint (value));
#line 20 "../src/puzzle.vala"
		break;
#line 2119 "puzzle.c"
		default:
#line 20 "../src/puzzle.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/puzzle.vala"
		break;
#line 2125 "puzzle.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

